/**************************************************************************
**
** Copyright (C) Computer Science Department, Worcester Polytechnic Institute,
**                           All rights reserved.
**
** MediaTracker V2.0 Source Code
**
** AUTHOR: Mingzhe Li       Oct-2002
**
/**************************************************************************/

// MediaTrackerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MediaTracker.h"
#include "MediaTrackerDlg.h"
#include <time.h>
#include <sys/types.h>
#include <sys/timeb.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define SAMPLE_INTERVAL 500

struct Statetext {
	long state;
	char * text;
} statetext[12] = {
	0, "Undefined",
	1, "Stopped",
	2, "Paused",
	3, "Playing",
	4, "ScanForward",
	5, "ScanReverse",
	6, "Buffering",
	7, "Waiting",
	8, "MediaEnded",
	9, "Transitioning",
	10, "Ready",
	11, "Reconnecting",
};
/*


*/
/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMediaTrackerDlg dialog

CMediaTrackerDlg::CMediaTrackerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMediaTrackerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMediaTrackerDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMediaTrackerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMediaTrackerDlg)
	DDX_Control(pDX, IDC_FPS, m_fps);
	DDX_Control(pDX, IDC_PLAYER, m_player);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMediaTrackerDlg, CDialog)
	//{{AFX_MSG_MAP(CMediaTrackerDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_OPEN, OnOpen)
	ON_BN_CLICKED(IDOK, OnPlay)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_ABOUT, OnAbout)
	ON_BN_CLICKED(IDC_HELP, OnHelp)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMediaTrackerDlg message handlers

BOOL CMediaTrackerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	//default log name
	GetLogName(&pszFileName); //"myfile.dat"; maybe overwrite if you put command line argv.
	shutdown_flag = 0;
	timer_reset = 0;
	Inittime = clock();

	// Parse the command line parameters, if error, ignore all.
	if (CommandParser() == -1) 
		AfxMessageBox ("All command line parameters are ignored");

	// Create log file, the name maybe overwrited by command line parameters
	CreateLog();
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMediaTrackerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMediaTrackerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMediaTrackerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CMediaTrackerDlg::OnOpen() 
{
	COpenDialog open_url;
	
	if (open_url.DoModal() == IDOK){
		m_player.SetUrl(open_url.m_url);
		//Set timer 500ms
		SetTimer(ID_TIMER, SAMPLE_INTERVAL, NULL);
	}	
}

void CMediaTrackerDlg::OnPlay() 
{
	SetTimer(ID_TIMER, SAMPLE_INTERVAL, NULL);
	m_player.GetControls().play();	
}



void CMediaTrackerDlg::OnStop() 
{
	KillTimer(ID_TIMER);
	m_player.GetControls().stop();	
}

void CMediaTrackerDlg::OnCancel() 
{
	m_player.GetControls().stop();
	KillTimer(ID_TIMER);
	myFile.Close();
	CDialog::OnCancel();
}

void CMediaTrackerDlg::OnTimer(UINT nIDEvent) 
{
	double fps;
	long brate, bw, bufp, maxbw, encodefr, frskipped, recpkt, lostpkt, recoverpkt, quality, bufcount, buflength, state;
	CString line, protocol;
	static clock_t startTime = clock();
	clock_t endTime;
	double elapsedTime, frate;
	static double framecount, frametime;
	
	if (timer_reset == 1 ) {
		startTime = clock();
		timer_reset = 0;
	}
	endTime = clock();
	elapsedTime = (double)(endTime - startTime) / CLOCKS_PER_SEC;

	// Get UTC time: 1/1/1970
	struct _timeb tstruct;
	_ftime( &tstruct );
    CString t;
	t.Format( "%d.%d", tstruct.time, tstruct.millitm );

	
	//Frame rate
	fps = m_player.GetNetwork().GetFrameRate()/100.0;
	line.Format("%2.2f",fps);
	m_fps.SetWindowText(line);

	//buffering count
	bufp = m_player.GetNetwork().GetBufferingProgress();

	//bit rate
	brate = m_player.GetNetwork().GetBitRate();

	//bandwidth
	bw = m_player.GetNetwork().GetBandWidth();

	//max bandwidth
	maxbw = m_player.GetNetwork().GetMaxBandwidth();

	//encoded frame rate
	encodefr = m_player.GetNetwork().GetEncodedFrameRate();
	
	//Frame skipped
	frskipped = m_player.GetNetwork().GetFramesSkipped();
	
	//Received packets
	recpkt = m_player.GetNetwork().GetReceivedPackets();
	
	//Lost packets
	lostpkt = m_player.GetNetwork().GetLostPackets();
	
	//recovered packets
	recoverpkt = m_player.GetNetwork().GetRecoveredPackets();
	
	//Reception Qualisy
	quality = m_player.GetNetwork().GetReceptionQuality();

	//protocol
	protocol = m_player.GetNetwork().GetSourceProtocol();

	//buffer
	bufcount = m_player.GetNetwork().GetBufferingCount();
	buflength = m_player.GetNetwork().GetBufferingTime();

	state = m_player.GetPlayState();

	// Compute the realtime frame rate.
	if ( state != 3 ) {
		// If we are not playing, frame rate =0;
		frate = 0;
	}
	else {
		double lasttime = frametime;
		double lastframe = framecount;
		frametime = (double)(endTime - Inittime) / CLOCKS_PER_SEC;
		framecount = fps * frametime;

		// If windows media did a reset between two samples
		if ((frametime < lasttime)) {
			lastframe = 0;
			lasttime = 0;
		}
		// For some reason, totalframe/totoaltime may decrease. In this case
		// set it to equal last sample.
		else if (framecount < lastframe) {
			framecount = lastframe;
		}
		// Media SDK did something strange -- after rebuffer, the 
		// first available sample of frame rate will delay once.
		else if  (lastframe == 0 && lasttime !=0 ) lasttime = 0;

		frate = (framecount - lastframe) / (frametime - lasttime);
	}

	line.Format("%d.%d\t%4.4f\t%3d\t%2d\t%5d\t%8d\t%8d\t%8d\t%2.2f\t%8d\t%3d\t%8d\t%8d\t%8d\t%8d\t%s\t%2.2f\t%s\n", 
		tstruct.time, tstruct.millitm,
		elapsedTime, bufp, bufcount, buflength, brate, bw, maxbw, fps, encodefr, frskipped, 
		recpkt, lostpkt, recoverpkt, quality, protocol, frate, statetext[state].text);
	myFile.Write(line, line.GetLength());

	CDialog::OnTimer(nIDEvent);
}

void CMediaTrackerDlg::CreateLog()
{
	CString line;
	CFileException fileException;
/*	CString strDirectory;
	CString file_name;
	CFileStatus status;

	GetCurrentDirectory( _MAX_PATH, strDirectory.GetBufferSetLength( _MAX_PATH ));
	strDirectory.ReleaseBuffer( );
	
	file_name = strDirectory + "\\data\\" + pszFileName;
	if( !CFile::GetStatus( "data", status ) ) {	
		MessageBox("A new folder \"data\" had been create under: \n\t" + strDirectory);
		CreateDirectory("data", NULL);
	}
*/

	if ( !myFile.Open( pszFileName, CFile::modeCreate | CFile::modeReadWrite ), &fileException ) {
		TRACE( "Can't open file %s, error = %u\n", pszFileName, fileException.m_cause );
	}
	line.Format("UTCTime\tTime\tBuf_Progress\tBufCount\tBufTime\tBit_Rate\tBandWidth\tMax_BandW\tFrame_Rate\tRncode_Fr\tFr_Skipped\tReceived_Pkts\tLost_Pkts\tRecover_Pkts\tQuality\tProtocol\tIFramerate\tPlayerState\n");
	myFile.Write(line, line.GetLength());
}

BEGIN_EVENTSINK_MAP(CMediaTrackerDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CMediaTrackerDlg)
	ON_EVENT(CMediaTrackerDlg, IDC_PLAYER, 5101 /* PlayStateChange */, OnPlayStateChangePlayer, VTS_I4)
	ON_EVENT(CMediaTrackerDlg, IDC_PLAYER, 5001 /* OpenStateChange */, OnOpenStateChangePlayer, VTS_I4)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CMediaTrackerDlg::OnPlayStateChangePlayer(long NewState) 
{

	switch(NewState){
	case 3:
		Inittime = clock();
		break;
	case 8:
		timer_reset = 1;
		if (shutdown_flag == 0) {
			shutdown_flag = 1;	
		}
		break;
	case 10:
		if (shutdown_flag == 1) {
			KillTimer(ID_TIMER);
			CShutDownDlg down;
			if (down.DoModal() == IDOK) {
				OnCancel();
			}			
		}
		break;
  }

}



int CMediaTrackerDlg::CommandParser()
{
	
switch (__argc) {
	case 1:
		return 1;
	case 2:
		m_player.SetUrl(__argv[1]);
		break;
	case 3:
		m_player.SetUrl(__argv[1]);
		pszFileName.Format("%s", __argv[2]);
		break;
	default:
		AfxMessageBox ("Error Command Lines input!\nUse\"MediaTracker playlist.wpl logfile\"");
		return -1;
	}

	SetTimer(ID_TIMER, SAMPLE_INTERVAL, NULL);	
	return 1;
}

void CMediaTrackerDlg::OnOpenStateChangePlayer(long NewState) 
{
	CString line1, line2, line3, line4;

	switch(NewState) {
	case 13:
		line1 = m_player.GetCurrentMedia().GetName();
		line2 = m_player.GetCurrentMedia().GetSourceURL();
		line3.Format("Duration: %s (%4.2f secs)", m_player.GetCurrentMedia().GetDurationString(), m_player.GetCurrentMedia().GetDuration());
		line4.Format("Resulation: %d*%d", m_player.GetCurrentMedia().GetImageSourceWidth(), m_player.GetCurrentMedia().GetImageSourceHeight());
		line1 = line1 + "\n" + line2 + "\n" + line3 + "\t" + line4 + "\n";		
		myFile.Write(line1, line1.GetLength());
	}
	
}

void CMediaTrackerDlg::OnAbout() 
{
	CAboutDlg dlgAbout;
	dlgAbout.DoModal();
	
}

void CMediaTrackerDlg::GetLogName(CString* logname)
{
	CString name;
	CTime theTime = CTime::GetCurrentTime();
	name = theTime.Format("%Y%m%d%H%M%S.dat");
	*logname = name;
	return;
}
