/**************************************************************************
**
** Copyright (C) Computer Science Department, Worcester Polytechnic Institute,
**                           All rights reserved.
**
** MediaTracker V2.0 Source Code
**
** AUTHOR: Mingzhe Li       Oct-2002
**
/**************************************************************************/
// MediaTrackerDlg.h : header file
//
//{{AFX_INCLUDES()
#include "wmpplayer4.h"
#include "wmpnetwork.h"
#include "wmpcontrols.h"
#include "wmpmedia.h"
#include "wmpplaylist.h"
#include "OpenDialog.h"
#include "ShutDownDlg.h"


//}}AFX_INCLUDES

#if !defined(AFX_MEDIATRACKERDLG_H__4535EB1C_B92A_437D_977D_E0BE24FC565A__INCLUDED_)
#define AFX_MEDIATRACKERDLG_H__4535EB1C_B92A_437D_977D_E0BE24FC565A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CMediaTrackerDlg dialog

class CMediaTrackerDlg : public CDialog
{
// Construction
public:
	void GetLogName(CString* logname);
	CMediaTrackerDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CMediaTrackerDlg)
	enum { IDD = IDD_MEDIATRACKER_DIALOG };
	CEdit	m_fps;
	CWMPPlayer4	m_player;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMediaTrackerDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;
	CFile myFile;
	CString pszFileName;
	int shutdown_flag;
	int timer_reset;
	clock_t Inittime;

	// Generated message map functions
	//{{AFX_MSG(CMediaTrackerDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnOpen();
	afx_msg void OnPlay();
	afx_msg void OnStop();
	virtual void OnCancel();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnPlayStateChangePlayer(long NewState);
	afx_msg void OnOpenStateChangePlayer(long NewState);
	afx_msg void OnAbout();
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	int CommandParser();
	void CreateLog();
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MEDIATRACKERDLG_H__4535EB1C_B92A_437D_977D_E0BE24FC565A__INCLUDED_)
