/**************************************************************************
**
** Copyright (C) Computer Science Department, Worcester Polytechnic Institute,
**                           All rights reserved.
**
** MediaTracker V2.0 Source Code
**
** AUTHOR: Mingzhe Li       Oct-2002
**
/**************************************************************************/
// OpenDialog.cpp : implementation file
//

#include "stdafx.h"
#include "MediaTracker.h"
#include "OpenDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COpenDialog dialog


COpenDialog::COpenDialog(CWnd* pParent /*=NULL*/)
	: CDialog(COpenDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(COpenDialog)
	m_url = _T("");
	//}}AFX_DATA_INIT
}


void COpenDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COpenDialog)
	DDX_Text(pDX, IDC_URL_EDIT, m_url);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(COpenDialog, CDialog)
	//{{AFX_MSG_MAP(COpenDialog)
	ON_BN_CLICKED(IDC_BROWSER, OnBrowser)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COpenDialog message handlers

void COpenDialog::OnOK() 
{
	UpdateData(TRUE);
	CDialog::OnOK();
}

void COpenDialog::OnBrowser() 
{
	static char BASED_CODE szFilter[] = "Media Playlist (*.wpl, *.asx)|*.wpl;*.asx|Windows Media (*.asf, *.wmv)|*.asf; *.wmv|All Files (*.*)|*.*||";
	CFileDialog openFile(TRUE, NULL, "playlist.wpl", OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, szFilter, NULL );
	if (openFile.DoModal() == IDOK) {
		m_url = openFile.GetPathName();
		UpdateData(FALSE);
	}
	
}
